// StarGazerSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "StarGazerSample.h"
#include "StarGazerSampleDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStarGazerSampleDlg dialog

CStarGazerSampleDlg::CStarGazerSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStarGazerSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStarGazerSampleDlg)
	m_pRecvData = _T("");
	m_pTransData = _T("");
	m_pRecvAck = _T("");
	m_pRecvGet = _T("");
	m_pIDNum = _T("");
	m_pRefID = _T("");
	m_pMarkHeight = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStarGazerSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStarGazerSampleDlg)
	DDX_Text(pDX, IDC_LBL_RECVDATA, m_pRecvData);
	DDX_Text(pDX, IDC_LBL_TRANSDATA, m_pTransData);
	DDX_Text(pDX, IDC_LBL_RECVACK, m_pRecvAck);
	DDX_Text(pDX, IDC_LBL_RECVGET, m_pRecvGet);
	DDX_Text(pDX, IDC_TXT_IDNUM_SEND, m_pIDNum);
	DDX_Text(pDX, IDC_TXT_REFID_SEND, m_pRefID);
	DDX_Text(pDX, IDC_TXT_MARKHEIGHT_SEND, m_pMarkHeight);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStarGazerSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CStarGazerSampleDlg)
	ON_MESSAGE(WM_RECEIVEDATA, OnReceiveData)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CALCSTART, OnCalcstart)
	ON_BN_CLICKED(IDC_CALCSTOP, OnCalcstop)
	ON_BN_CLICKED(IDC_CMD_EXIT, OnCmdExit)
	ON_BN_CLICKED(IDC_SETEND, OnSetend)
	ON_BN_CLICKED(IDC_CMD_IDNUM_SEND, OnCmdIdnumSend)
	ON_BN_CLICKED(IDC_CMD_REFID_SEND, OnCmdRefidSend)
	ON_BN_CLICKED(IDC_CMD_MARKHEIGHT_AUTOCAL, OnCmdMarkheightAutocal)
	ON_BN_CLICKED(IDC_CMD_MARKHEIGHT_SEND, OnCmdMarkheightSend)
	ON_BN_CLICKED(IDC_CMD_MARKTYPE_HOME, OnCmdMarktypeHome)
	ON_BN_CLICKED(IDC_CMD_MARKTYPE_OFFICE, OnCmdMarktypeOffice)
	ON_BN_CLICKED(IDC_CMD_MARKMODE_ALONE, OnCmdMarkmodeAlone)
	ON_BN_CLICKED(IDC_CMD_MARKMODE_MAP, OnCmdMarkmodeMap)
	ON_BN_CLICKED(IDC_CMD_MAPMODE_START, OnCmdMapmodeStart)
	ON_BN_CLICKED(IDC_CMD_MAPMODE_STOP, OnCmdMapmodeStop)
	ON_BN_CLICKED(IDC_CMD_IDNUM_GET, OnCmdIdnumGet)
	ON_BN_CLICKED(IDC_CMD_REFID_GET, OnCmdRefidGet)
	ON_BN_CLICKED(IDC_CMD_MARKHEIGHT_GET, OnCmdMarkheightGet)
	ON_BN_CLICKED(IDC_CMD_MARKTYPE_GET, OnCmdMarktypeGet)
	ON_BN_CLICKED(IDC_CMD_MARKMODE_GET, OnCmdMarkmodeGet)
	ON_BN_CLICKED(IDC_CMD_MAPMODE_GET, OnCmdMapmodeGet)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStarGazerSampleDlg message handlers

BOOL CStarGazerSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//////////// Serial Communication Setting ////////
	CSerial.SetHwnd(this->m_hWnd);
	CSerial.SetComport(1, 115200, 8, 0, 0);		//port, baudrate, databit, stopbit, paritybit
	CSerial.CreateCommInfo();
	CSerial.OpenComport();

	CSerial.m_bStartFlag = TRUE;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

////// Serial Communication Message Handler ////////
LONG CStarGazerSampleDlg::OnReceiveData(UINT WParam, LONG LParam)
{
	UpdateData(TRUE);

	int num_ETX	= CSerial.m_pInBuffer.Find("`");
	int len		= CSerial.m_pInBuffer.GetLength();

	while (num_ETX!=-1) {
		CSerial.m_pBuffer	= CSerial.m_pInBuffer.Left(num_ETX+1);
		CSerial.m_pInBuffer = CSerial.m_pInBuffer.Right(len-num_ETX-1);

		num_ETX	= CSerial.m_pInBuffer.Find("`");
		len		= CSerial.m_pInBuffer.GetLength();

		if (CSerial.m_pBuffer.Left(2)=="~!") m_pRecvAck = CSerial.m_pBuffer;
		else if (CSerial.m_pBuffer.Left(2)=="~$") {
			m_pRecvGet = CSerial.m_pBuffer;

		}
		else if (CSerial.m_pBuffer.Left(2)=="~^") {
			m_pRecvData = CSerial.m_pBuffer;
		}

		UpdateData(FALSE);
	}

	return TRUE;
}

void CStarGazerSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CStarGazerSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CStarGazerSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CStarGazerSampleDlg::OnCalcstart() 
{
	CommDataOut('#', "CalcStart");
}

void CStarGazerSampleDlg::OnCalcstop() 
{
	CommDataOut('#', "CalcStop");
}

void CStarGazerSampleDlg::OnCmdExit() 
{
	// TODO: Add your control notification handler code here
	OnOK();	
}

void CStarGazerSampleDlg::CommDataOut(char mode, char *pTxData)
{
	char aTxData[80];

	sprintf(aTxData, "~%c%s`", mode, pTxData);
	for(int i = 0; i < (int)strlen(aTxData) ; i++) {
		CSerial.WriteCommBlock(&aTxData[i], 1);
		Sleep(30);
	}

	m_pTransData = aTxData;
	UpdateData(FALSE);

}

void CStarGazerSampleDlg::OnSetend() 
{
	CommDataOut('#', "SetEnd");
}

void CStarGazerSampleDlg::OnCmdIdnumSend() 
{
	CString pTxData;

	UpdateData(TRUE);
	pTxData = "IDNum|" + m_pIDNum;

	CommDataOut('#', pTxData.GetBuffer(pTxData.GetLength()));
}

void CStarGazerSampleDlg::OnCmdRefidSend() 
{
	CString pTxData;

	UpdateData(TRUE);
	pTxData = "RefID|" + m_pRefID;

	CommDataOut('#', pTxData.GetBuffer(pTxData.GetLength()));
}

void CStarGazerSampleDlg::OnCmdMarkheightAutocal() 
{
	CommDataOut('#', "HeightCalc");
}

void CStarGazerSampleDlg::OnCmdMarkheightSend() 
{
	CString pTxData;

	UpdateData(TRUE);
	pTxData = "MarkHeight|" + m_pMarkHeight;

	CommDataOut('#', pTxData.GetBuffer(pTxData.GetLength()));
}

void CStarGazerSampleDlg::OnCmdMarktypeHome() 
{
	CommDataOut('#', "MarkType|Home");
}

void CStarGazerSampleDlg::OnCmdMarktypeOffice() 
{
	CommDataOut('#', "MarkType|Office");
}

void CStarGazerSampleDlg::OnCmdMarkmodeAlone() 
{
	CommDataOut('#', "MarkMode|Alone");
}

void CStarGazerSampleDlg::OnCmdMarkmodeMap() 
{
	CommDataOut('#', "MarkMode|Map");
}

void CStarGazerSampleDlg::OnCmdMapmodeStart() 
{
	CommDataOut('#', "MapMode|Start");
}

void CStarGazerSampleDlg::OnCmdMapmodeStop() 
{
	CommDataOut('#', "MapMode|Stop");
}

void CStarGazerSampleDlg::OnCmdIdnumGet() 
{
	CommDataOut('@', "IDNum");
}

void CStarGazerSampleDlg::OnCmdRefidGet() 
{
	CommDataOut('@', "RefID");
}

void CStarGazerSampleDlg::OnCmdMarkheightGet() 
{
	CommDataOut('@', "MarkHeight");
}

void CStarGazerSampleDlg::OnCmdMarktypeGet() 
{
	CommDataOut('@', "MarkType");
}

void CStarGazerSampleDlg::OnCmdMarkmodeGet() 
{
	CommDataOut('@', "MarkMode");
}

void CStarGazerSampleDlg::OnCmdMapmodeGet() 
{
	CommDataOut('@', "MapMode");
}
